package struts.kenkyu04.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import struts.kenkyu04.dao.ProductDao;
import struts.kenkyu04.dto.ProductRecord;
import struts.kenkyu04.form.ProductEditForm;

public class ProductEditAction extends BaseAction {
	/**
	 * ҏWʕ\(cmd=edit)
	 */
	public ActionForward edit(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		//ꗗʂőIҏWΏ(ActionForm)
		ProductEditForm editForm = (ProductEditForm)form;
		
		//DAOŕҏWΏۃR[h擾
		ProductRecord record = ProductDao.findByPK(getConn(request), 
				Integer.parseInt(editForm.getPcode()));
		
		//R[heditForm
		BeanUtils.copyProperties(editForm, record);
		
		//ҏWʂ̑Jڐ𔻕ʂtO
		request.setAttribute("isUpdate", Boolean.TRUE);
		
		return mapping.findForward("edit");
		
	}
	/**
	 * VK쐬ʕ\(cmd=editnew)
	 */
	public ActionForward editnew(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		//ҏWʂ̑Jڐ𔻕ʂtO
		request.setAttribute("isUpdate", Boolean.FALSE);
		return mapping.findForward("edit");
		
	}
	
	/**
	 * XV(cmd=update)
	 */
	public ActionForward update(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		//ҏWʂŕҏWB
		ProductEditForm editForm = (ProductEditForm)form;

		//XV̏i
		ProductRecord newValue = new ProductRecord();
		BeanUtils.copyProperties(newValue, editForm);

		//DAOgčXV
		ProductDao.updateByPK(getConn(request), newValue.getPcode().intValue(), newValue);
		
		return mapping.findForward("success");
	}
	/**
	 * o^(cmd=insert)
	 */
	public ActionForward insert(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		//ҏWʂŕҏWB
		ProductEditForm editForm = (ProductEditForm)form;

		//Vi
		ProductRecord newValue = new ProductRecord();
		BeanUtils.copyProperties(newValue, editForm);

		//DAOgčXV
		ProductDao.insert(getConn(request), newValue);
		
		return mapping.findForward("success");
	}
	
	/**
	 * 폜(cmd=delete)
	 */
	public ActionForward delete(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {

		//ҏWʂŕҏWB
		ProductEditForm editForm = (ProductEditForm)form;

		//DAOgč폜
		ProductDao.deleteByPK(getConn(request), Integer.parseInt(editForm.getPcode()));
		
		return mapping.findForward("success");
	}	
}
